package com.iloomo.service.core.impl;
import java.util.Map;
import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.iloomo.entity.core.KeyValue;
import com.iloomo.service.core.KeyValueManager;
import com.iloomo.dao.core.KeyValueDao;
import com.iloomo.util.PageData;
import com.iloomo.util.PagerModel;

/** 
 * 说明：表 keyValue业务逻辑处理类
 * 创建人：system
 * 创建时间：2020-02-13
 * @version
 */
@Service("keyValueService")
public class KeyValueService implements KeyValueManager{

	@Resource(name = "keyValueDao")
	private KeyValueDao keyValueDao;
	
	/**新增
	 * @param pd
	 * @throws Exception
	 */
	@Override
	public int save(PageData pd) throws Exception{
		return keyValueDao.save(pd);
	}
	
	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	@Override
	public Map findById(PageData pd) throws Exception{
		return keyValueDao.findById(pd);
	}
	
	/**删除
	 * @param pd
	 * @throws Exception
	 */
	@Override
	public int deleteById(PageData pd) throws Exception{
		return keyValueDao.deleteById(pd);
	}
	
	/**修改
	 * @param pd
	 * @throws Exception
	 */
	@Override
	public int updateById(PageData pd) throws Exception{
		return keyValueDao.updateById(pd);
	}
	
	/**列表(分页)
	 * @param pd
	 * @throws Exception
	 */
	@Override
	public PagerModel list(PageData pd) throws Exception{
		return keyValueDao.list(pd);
	}
	
	/**列表(全部)
	 * @param pd
	 * @throws Exception
	 */
	@Override
	public List<Map> listAll(PageData pd) throws Exception{
		return keyValueDao.listAll(pd);
	}
	/**批量保存
	* @param objs
	* @throws Exception
	*/
	@Override
	public Object batchSave(List objs) throws Exception{
		return keyValueDao.batchSave(objs);
	}

	/**列表(分页)
	* @param pd
	* @throws Exception
	*/
	@Override
	public PagerModel listWithLike(PageData pd) throws Exception{
	return keyValueDao.listWithLike(pd);
	}

	/**列表(全部)
	* @param pd
	* @throws Exception
	*/
	@Override
	public List<Map> listAllWithLike(PageData pd) throws Exception{
		return keyValueDao.listAllWithLike(pd);
	}

	/**获取数量
	* @param pd
	* @ throws Exception
	*/
	@Override
	public int selectCount(PageData pd) throws Exception {
		return keyValueDao.selectCount(pd);
	}
}

